unit UnitFormScaling;

interface


uses Generics.Collections, Forms;

type TFormScaling = class
    private
        class var forms : TList<TForm>;
    public
        class procedure RegisterSelf(value : TForm);
        class procedure GetRegistrationList(var list : TList<TForm>);
end;

implementation

class procedure TFormScaling.RegisterSelf(value : TForm);
begin
    if not assigned(forms) then begin
        forms := TList<TForm>.create;
    end;

    forms.Add(value);
end;

class procedure TFormScaling.GetRegistrationList(var list : TList<TForm>);
var f : TForm;
begin
    for f in forms do begin
        list.Add(f);
    end;
end;

end.
