unit UnitFrameReplaceNameExtPhrase;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, 
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, UnitFrameSteps;

type
  TFrameReplaceNameExtPhrase = class(TFrame)
    pnlReplace: TPanel;
    lblWith: TLabel;
    lblReplaceThe: TLabel;
    cbxReplacePart: TComboBox;
    txtReplacePhrase: TEdit;
    txtReplaceWith: TEdit;
    pnlReplaceOnly: TPanel;
    lblThru: TLabel;
    cbReplaceOnly: TCheckBox;
    txtRP2X: TEdit;
    udRP2X: TUpDown;
    txtRP2Y: TEdit;
    udRP2Y: TUpDown;
    procedure cbxReplacePartChange(Sender: TObject);
  private
    { Private declarations }
    host : TFrameStep;
  public
    { Public declarations }
    constructor Create(aowner : TComponent);
    procedure SetHost( fs : TFrameStep );
  end;

implementation



{$R *.dfm}

procedure TFrameReplaceNameExtPhrase.cbxReplacePartChange(Sender: TObject);
    procedure SetReplaceOnlyVisible(v : boolean);
    var i : integer;
    begin
        for i := 0 to pnlReplaceOnly.ControlCount - 1 do begin
            pnlReplaceOnly.Controls[i].Visible := v;
        end;
    end;
begin

    //sar := TScriptStepReplaceNameExtension(StepReplaceList.Items[TWinControl(sender).Tag]);

    txtReplacePhrase.Visible := false;
    txtReplacePhrase.Parent.Visible := false;

    SetReplaceOnlyVisible(false);


    case cbxReplacePart.ItemIndex of
    0,1:
        begin
        end;
    2:
        begin
            txtReplacePhrase.Visible := true;
            txtReplacePhrase.Parent.Visible := true;

            SetReplaceOnlyVisible(true);
        end;

    end;

    //self.HandleKeypress(sender, sstReplace);

end;

constructor TFrameReplaceNameExtPhrase.Create(aowner: TComponent);
begin
    inherited create(aowner);

    FrameList.AddInsert(txtReplacePhrase);
    FrameList.AddInsert(txtReplaceWith); 
end;

procedure TFrameReplaceNameExtPhrase.SetHost(fs: TFrameStep);
begin
    self.host := fs;
end;

end.
