unit UnitFrmMetaVariables2;

interface

uses
  Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ComCtrls, Vcl.ExtCtrls,
  UnitFrameCheckFilesDropdown, Vcl.Buttons, System.Generics.Collections,
  Vcl.Menus, System.StrUtils, System.IOUtils, UnitFrameFileTags;

type TRadioList = TList<TRadioButton>;
type
  TfrmMetaVariables = class(TForm)
  {$region 'default'}
    cpgVariables: TCategoryPanelGroup;
    cpCounting: TCategoryPanel;
    cpDateToday: TCategoryPanel;
    rbFCTotalSelected: TRadioButton;
    rbFCCurrent: TRadioButton;
    rbRFTotal: TRadioButton;
    Label1: TLabel;
    fcUpDown: TUpDown;
    rbFCTotalFolder: TRadioButton;
    txtZeros: TEdit;
    cpDate: TCategoryPanel;
    cpSize: TCategoryPanel;
    cpName: TCategoryPanel;
    rbFPDateCreated: TRadioButton;
    rbFPDateshort: TRadioButton;
    rbFPDatemedium: TRadioButton;
    rbFPDatelong: TRadioButton;
    rbFPDateModified: TRadioButton;
    rbFSBytes: TRadioButton;
    rbFSKilos: TRadioButton;
    rbFSMegs: TRadioButton;
    rbFSGigs: TRadioButton;
    cbxLayout: TComboBox;
    rbFPType: TRadioButton;
    rbFPCurFolder: TRadioButton;
    rbFPParent: TRadioButton;
    rbFilenameOnly: TRadioButton;
    rbFPName: TRadioButton;
    rbFileContents: TRadioButton;
    cbxTextEncode: TComboBox;
    txtContentsA: TEdit;
    Label2: TLabel;
    txtContentsb: TEdit;
    rbTDDateshort: TRadioButton;
    rbTDDateMedium: TRadioButton;
    rbTDDatelong: TRadioButton;
    pnOutput: TPanel;
    lblData: TLabel;
    lblPreview: TLabel;
    pnlFormat: TPanel;
    btnSetFormat: TSpeedButton;
    lblFormat: TLabel;
    pnlFile: TPanel;
    Label19: TLabel;
    FrameCheckedFileDropdown1: TFrameCheckedFileDropdown;
    pcFormat: TPageControl;
    TabSheet1: TTabSheet;
    Label5: TLabel;
    TabSheet2: TTabSheet;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    cbPad: TComboBox;
    txtChar: TEdit;
    txtLength: TEdit;
    UpDown1: TUpDown;
    TabSheet3: TTabSheet;
    Label10: TLabel;
    Label11: TLabel;
    txtDecimal: TEdit;
    UpDown2: TUpDown;
    TabSheet4: TTabSheet;
    Label12: TLabel;
    Label13: TLabel;
    btnFormatExample: TSpeedButton;
    txtDateFormat: TEdit;
    cbxAlter: TComboBox;
    txtAlterAmount: TEdit;
    cbxAlterUnits: TComboBox;
    TabSheet5: TTabSheet;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    txtHexPad: TEdit;
    UpDown3: TUpDown;
    TabSheet6: TTabSheet;
    Label3: TLabel;
    Label17: TLabel;
    txtSubX: TEdit;
    txtSubY: TEdit;
    TabSheet7: TTabSheet;
    Label18: TLabel;
    cbStartWithZero: TCheckBox;
    pnlPreview: TPanel;
    pnlFormatSettings: TPanel;
    pnlData: TPanel;
    pnlSelect: TPanel;
    pnlRight: TPanel;
    pnlContent: TPanel;
    btnFormatInsert: TButton;
    btnFormatClose: TButton;
    pnl1: TPanel;
    pnl2: TPanel;
    pnl3: TPanel;
    pnl4: TPanel;
    pnl5: TPanel;
    pnl6: TPanel;
    pnl7: TPanel;
    pnl8: TPanel;
    pnl10: TPanel;
    pnl11: TPanel;
    pnl12: TPanel;
    pnl13: TPanel;
    pnl14: TPanel;
    pnl15: TPanel;
    pnl16: TPanel;
    pnl17: TPanel;
    pnl18: TPanel;
    pnl19: TPanel;
    pnl20: TPanel;
    pnl21: TPanel;
    pnl22: TPanel;
    pnl23: TPanel;
    pnl24: TPanel;
    pnl25: TPanel;
    pmFormat: TPopupMenu;
    none1: TMenuItem;
    N1: TMenuItem;
    AddPadding1: TMenuItem;
    AddDecimalPoint1: TMenuItem;
    DateTimeFormatting1: TMenuItem;
    Hexidecimal1: TMenuItem;
    Substring1: TMenuItem;
    ChangeNumberstoLetters1: TMenuItem;
    pmDateExamples: TPopupMenu;
    yyyymmddformat1: TMenuItem;
    yyyymmddhhmmssformat1: TMenuItem;
    N24hourtimehhmmss1: TMenuItem;
    pnlLeft: TPanel;
    pnlSelectHeader: TPanel;
    Label4: TLabel;
    lblVar: TLabel;
    pmInsert: TPopupMenu;
    Insertandstayopen1: TMenuItem;
    cbStayOpen: TCheckBox;
    cpTags: TCategoryPanel;
    pnlExtension: TPanel;
    lblFileType: TLabel;
    pnlTags: TPanel;
    framFileTags1: TframFileTags;
    timFileTags: TTimer;
    Label20: TLabel;
    Dateand12hourTime1: TMenuItem;
    procedure rbVariableClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnFormatCloseClick(Sender: TObject);
    procedure PanelExpand(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure btnSetFormatClick(Sender: TObject);
    procedure FormatClick(Sender: TObject);
    procedure pmFormatPopup(Sender: TObject);
    procedure ChangeHandler(Sender: Tobject);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure btnFormatInsertClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure btnFormatExampleClick(Sender: TObject);
    procedure yyyymmddformat1Click(Sender: TObject);
    procedure Insertandstayopen1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure timFileTagsTimer(Sender: TObject);
    procedure cpgVariablesResize(Sender: TObject);
    {$ENDREGION}
  private
    { Private declarations }
     TargetEditControl : TCustomEdit;

     listCount : TRadioList;
     listDate : TRadioList;
     listName : TRadioList;
     ListSize : TRadioList;
     listDateToday : TRadioList;

     selectedVar : string;
     previewFile : string;
     lastFile : string;
     FormatText : string;
     OriginalFormatting : String;
     previewRaw : string;
     formLoaded : boolean;
     FormatMode : boolean;
     procedure InitForm;
     procedure setDisplayPosotion;
     procedure SetDefaultFile;
     procedure SetDefaultVar;
     procedure SetFormatPage(i: integer);

     procedure FileSelectedCallback(filename : string);
     procedure UpdatePreview;
     procedure ParseFormatting(s: string);
     function MetaFormat(s : string) : string;
     procedure SetVariable(code : string);
     procedure UpdateExtensionPanel;
     procedure FileTagCallback(tagVar : string);

     procedure cpgVariables_MouseWheel(Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint);
      procedure sbMain_MouseWheel(Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint);

  public
    { Public declarations }


    procedure ShowForm(t: TCustomEdit);
    procedure ShowFormFormat(t: TCustomEdit; ShowPage : integer = -1);
  end;

var
  frmMetaVariables: TfrmMetaVariables;

implementation

{$R *.dfm}

uses UnitFrmMain, UnitMetaVariables, UnitUtil, UnitFrmDummyShowPreview,
  UnitToken, UnitWildcards, UnitFormScaling;


const supported_files : array[0..10] of string =
  ('.jpeg','.jpg','.mp3','.avi','.mpg','.mpg',
                   '.mov','.mp4','.m4v','.asf','.wmv');

type FormatPageName = (
    pnNone,
    pnPadding,
    pnDecimal,
    pnDate,
    pnHex,
    pnSubstring,
    pnLetters
);


procedure TfrmMetaVariables.ShowForm(t: TCustomEdit);
var prevWidth : integer;
    i : integer;
begin
    self.TargetEditControl := t;

    prevWidth := self.ClientWidth;
    i := pnlLeft.Constraints.MinWidth + pnlRight.Constraints.MinWidth + pnlContent.Constraints.MinWidth;
    if prevWidth < i then begin
        pnlLeft.width := pnlLeft.Constraints.MinWidth;
        pnlContent.Width := pnlContent.Constraints.MinWidth;
        pnlRight.Width := pnlRight.Constraints.MinWidth;
        self.ClientWidth := i;
    end;
    if not pnlLeft.Visible then begin
        pnlLeft.Visible := true;
    end;

    cbStayOpen.Visible := true;
    btnFormatClose.Visible := false;

    self.FormatMode := false;
    self.InitForm;
    self.ShowModal;
end;
procedure TfrmMetaVariables.ShowFormFormat(t: TCustomEdit; ShowPage : integer = -1);
    procedure getVariableText;
    var s : string;
    begin
        s := t.SelText;
        self.SetVariable(s);
        s[1] := '?';
        s[length(s)] := '?';
        FormatText := s;
    end;
    procedure ShowPageOrSetFromVariable;
    var wc : TWildCards;
    begin
        if ShowPage = -1 then begin
            wc := TRegExpWildcards.Create;
            wc.SetSearchString(FormatText);
            wc.SetSearchPattern('\:[^?]*');

            OriginalFormatting := wc.FindString;
            FormatText := wc.SearchReplaceWith(FormatText,'\:.*\?','?',false);
            wc.free;
            self.SetVariable(FormatText);
            self.ParseFormatting(OriginalFormatting);
        end else begin
             self.SetFormatPage(ShowPage)
        end;
    end;
var i : integer;
begin
    self.TargetEditControl := t;


    i := pnlContent.Constraints.MinWidth + pnlRight.Width;
    pnlLeft.Visible := false;
    self.Width := i;




    pcFormat.ActivePageIndex := ShowPage;

    getVariableText;
    ShowPageOrSetFromVariable;

    self.FormatMode := true;
    cbStayOpen.Visible := false;


    self.InitForm;
    self.ShowModal;
end;
procedure TfrmMetaVariables.timFileTagsTimer(Sender: TObject);
begin

   timFileTags.Enabled := false;
   framFileTags1.extractFrom(
        TPath.Combine( FrmMain.GetPath,self.previewFile )
    );
end;

procedure TfrmMetaVariables.InitForm;
begin
    if self.FormatMode then begin
        btnFormatInsert.Caption := 'Edit';
    end else begin
        btnFormatInsert.Caption := 'Insert';
    end;
    self.SetDefaultFile;
    self.setDisplayPosotion;
    self.SetDefaultVar;
    self.UpdatePreview;
end;
procedure TfrmMetaVariables.Insertandstayopen1Click(Sender: TObject);
begin
    Insertandstayopen1.Checked := not Insertandstayopen1.Checked;
end;

procedure TfrmMetaVariables.SetDefaultFile;
var fld : TFileListData;
begin
    self.lastFile := previewFile;
    self.previewFile := FrmMain.getLastSelectedCaption;
    if self.previewFile = ''  then begin
        if FrmMain.FirstFileIndex <> -1 then begin
            fld := FrmDummyShowPreview.GetFileData(FrmMain.FirstFileIndex);
            self.previewFile := fld.caption;
        end;
    end;

    if (lastfile <> previewfile) then begin
        framFileTags1.extractFrom(
            TPath.Combine( FrmMain.GetPath, self.previewFile)
        );
    end;

    FrameCheckedFileDropdown1.setCurrent(self.previewFile);
    self.UpdateExtensionPanel;
end;
procedure TfrmMetaVariables.setDisplayPosotion;
begin
    self.top := frmmain.top + trunc(frmmain.Height / 2) - trunc(self.Height/2);
    self.left := frmmain.left + trunc(frmmain.width / 2) - trunc(self.width/2);
end;
procedure TfrmMetaVariables.SetDefaultVar;
var i : integer;
    cp : TCategoryPanel;
begin
    for i := 0 to cpgVariables.Panels.Count - 1 do begin
        cp := cpgVariables.Panels.Items[i];
        if not cp.Collapsed then begin
            self.PanelExpand(cp);
        end;
    end;
end;
procedure TfrmMetaVariables.SetVariable(code : string);
begin
    self.selectedVar := code;
    lblVar.Caption := UnitMetaVariables.GetFriendlyName(code);
end;



procedure TfrmMetaVariables.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    framFileTags1.deInit;
end;

procedure TfrmMetaVariables.FormCreate(Sender: TObject);
var i : integer;
    cp : TCategoryPanel;
    str : string;
begin
    // always on top
//     Windows.SetWindowPos(self.Handle, HWND_TOPMOST, 0, 0, 0, 0,
//        (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOOWNERZORDER or
//                         SWP_NOZORDER Or SWP_FRAMECHANGED ) and not SWP_NOZORDER);


    for i := 0 to pcFormat.PageCount - 1 do begin
        pcFormat.Pages[i].TabVisible := false;
    end;
    pcFormat.ActivePageIndex := 0;



    listCount := TList<TRadioButton>.Create;
    listName := TList<TRadioButton>.Create;
    ListSize := TList<TRadioButton>.Create;
    listDate := TList<TRadioButton>.Create;
    listDateToday := TList<TRadioButton>.Create;

    listCount.Add(rbFCTotalSelected);
    listCOunt.Add(rbFCCurrent);
    listCount.Add(rbRFTotal);
    listCount.Add(rbFCTotalFolder);

    listName.Add(rbFPType);
    listName.Add(rbFPName);
    listName.Add(rbFPCurFolder);
    listName.Add(rbFPParent);
    listName.Add(rbFilenameOnly);
    listName.Add(rbFileContents);

    listSize.Add(rbFSBytes);
    listSize.Add(rbFSKilos);
    listSize.Add(rbFSMegs);
    listSize.Add(rbFSGigs);

    listDate.Add(rbFPDateshort);
    listDate.Add(rbFPDatemedium);
    listDate.Add(rbFPDatelong);
    listDate.Add(rbFPDateCreated);
    listDate.Add(rbFPDateModified);

    listDateToday.add(rbTDDateshort);
    listDateToday.add(rbTDDateMedium);
    listDateToday.add(rbTDDatelong);

    self.lastFile := '';
    self.previewFile := '';

    FrameCheckedFileDropdown1.setOnSelected(self.FileSelectedCallback);
    FrameCheckedFileDropdown1.setFileList(GetFileList);

    cpgVariables.CollapseAll;
    for i := 0 to cpgVariables.ControlCount - 1 do begin
        if cpgVariables.Controls[i] is TCategoryPanel then begin
            cp := TCategoryPanel(cpgVariables.Controls[i]);
            cp.OnExpand := self.PanelExpand;
        end;
    end;
    cpCounting.Collapsed := false;

    for i := 0 to Length(supported_files)-1 do begin
        str := str + supported_files[i] + ' ';
    end;
    lblFileType.Caption := lblFileType.Caption + str;

    framFileTags1.setOnSelected(self.FileTagCallback);

    TFormScaling.RegisterSelf(self);

end;
procedure TfrmMetaVariables.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key = Ord(#27) then btnFormatClose.Click;
end;
procedure TfrmMetaVariables.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
var pt : TPoint;
begin
    pt := Mouse.CursorPos;
    Winapi.Windows.ScreenToClient(framFileTags1.sbMain.handle, pt);
    if PtInRect(
        framFileTags1.sbMain.BoundsRect,
        pt
    ) then begin
        sbMain_MouseWheel(Shift, WheelDelta, mousePos);
        handled := true;
    end else if PtInRect(cpgVariables.BoundsRect, ScreenToClient(Mouse.CursorPos)) then begin
        cpgVariables_MouseWheel(Shift, WheelDelta, MousePos);
        handled := true;
    end;
end;
procedure TfrmMetaVariables.FormResize(Sender: TObject);
var i : integer;
begin
    i := self.ClientWidth;
end;

procedure TfrmMetaVariables.sbMain_MouseWheel(
  Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint
);
var
  msg: Cardinal;
  code: Cardinal;
  i, n: Integer;
begin
    msg := WM_VSCROLL;
    code := SB_LINEDOWN;

    if ssShift in Shift then begin
        msg := WM_HSCROLL;
    end;
    if WheelDelta > 0 then begin
        code := SB_LINEUP;
    end;

    n := Mouse.WheelScrollLines;
    for i:= 0 to n-1 do begin
        framFileTags1.sbMain.Perform(msg, code, 0);
    end;
    framFileTags1.sbMain.Perform(msg, SB_ENDSCROLL, 0);
end;


procedure TfrmMetaVariables.cpgVariablesResize(Sender: TObject);
begin
    cptags.Height := cpgVariables.ClientHeight;
end;

procedure TfrmMetaVariables.cpgVariables_MouseWheel(Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint);
var
  msg: Cardinal;
  code: Cardinal;
  i, n: Integer;
begin
    msg := WM_VSCROLL;
    code := SB_LINEDOWN;

    if ssShift in Shift then begin
        msg := WM_HSCROLL;
    end;
    if WheelDelta > 0 then begin
        code := SB_LINEUP;
    end;

    n := Mouse.WheelScrollLines;
    for i:= 0 to n-1 do begin
        cpgVariables.Perform(msg, code, 0);
    end;
    cpgVariables.Perform(msg, SB_ENDSCROLL, 0);
end;

procedure TfrmMetaVariables.PanelExpand(Sender: TObject);
var i : integer;
    cp : TCategoryPanel;
    rb : TRadioButton;
    function checkedRB(cp : TCategoryPanel) : TRadioButton;
    var i, j : integer;
        p : TPanel;
        cps : TCategoryPanelSurface;
    begin
        result := nil;
        cps := TCategoryPanelSurface(cp.Controls[0]);

        for i := 0 to cps.ControlCount-1 do begin
            if cps.Controls[i] is TPanel then begin
                p := TPanel(cps.controls[i]);
                for j := 0 to p.ControlCount - 1 do begin
                    if p.Controls[j] is TRadioButton then begin
                        if TRadioButton(p.Controls[j]).Checked then begin
                            result := TRadioButton(p.Controls[j]);
                            EXIT;
                        end;
                    end;
                end;
            end;
        end;
    end;
begin
    if FormatMode then EXIT;

    for i := 0 to cpgVariables.ControlCount - 1 do begin
        if cpgVariables.Controls[i] is TCategoryPanel then begin
            cp := TCategoryPanel(cpgVariables.Controls[i]);
            if cp <> sender then begin
                cp.Collapsed := true;
            end;
        end;
    end;

    cp := TCategoryPanel(sender);

    rb := checkedRB(cp);
    if rb <> nil then begin
        rb.OnClick(rb);
    end;

    if sender = cpTags then begin
        //timFileTags.Enabled := true;
        if self.Visible and framFileTags1.Visible then begin
            framFileTags1.cbxFilter.SetFocus;
        end;
    end;
end;


procedure TfrmMetaVariables.btnFormatExampleClick(Sender: TObject);
begin
    UnitUtil.ShowPopupRight(btnFormatExample, pmDateExamples);
end;

procedure TfrmMetaVariables.btnFormatInsertClick(Sender: TObject);
var start, len : integer;
begin
    if FormatMode then begin
        start := TargetEditControl.SelStart;
        len := TargetEditControl.SelLength;
        TargetEditControl.SelText := MetaFormat(selectedVar);
        TargetEditControl.SelStart := start;
        TargetEditControl.SelLength := len;
        btnFormatClose.Click;
    end else begin
        TargetEditControl.SelText := MetaFormat(selectedVar);
        if not cbStayOpen.Checked then
            BtnFormatClose.click;
    end;
end;
procedure TfrmMetaVariables.btnFormatCloseClick(Sender: TObject);
begin
    self.ModalResult := mrOk;
end;

procedure TfrmMetaVariables.btnSetFormatClick(Sender: TObject);
begin
    UnitUtil.ShowPopupRight(btnSetFormat, pmFormat);
end;


procedure TfrmMetaVariables.pmFormatPopup(Sender: TObject);
var isInt, isDate : boolean;
    s, testDate : string;
    long : LONGLONG;
    i : LongWord;
    dt : TDateTime;

begin
    for i := 0 to pmFormat.Items.count - 1 do begin
        pmformat.Items[i].Enabled := true;
    end;
    s := previewRaw;

    if (s <> '') and (not ContainsTerm('?', s)) then begin

        isInt := UnitUtil.StringIsInt(s);
        isDate := UnitUtil.StringIsDate(s);

        isDate := isDate or StringIn(
            lowercase(FormatText),
            ['?cds?','?cdm?','?cdl?','?ds?','?dm?','?dl?','?dmo?','?dc?',
            '?x_dt?','?x_dto?','?x_dtd?','?x_sst?','?x_ssto?','?x_sstd?']
        );


        AddDecimalPoint1.Enabled := isInt;
        Hexidecimal1.Enabled := isInt;
        ChangeNumberstoLetters1.Enabled := isInt;

        DateTimeFormatting1.Enabled := isDate;
    end;

end;
procedure TfrmMetaVariables.yyyymmddformat1Click(Sender: TObject);
begin
    txtDateFormat.text := TMenuItem(sender).Hint;
end;


procedure TfrmMetaVariables.SetFormatPage(i: integer);
begin
    pcFormat.ActivePageIndex := i;

    case FormatPageName(i) of
    pnPadding:
        lblFormat.Caption := 'Add Padding';
    pnDecimal:
        lblFormat.Caption := 'Add Decimal Point';
    pnDate:
        lblFormat.Caption := 'Change Date/Time ';
    pnHex:
        lblFormat.Caption := 'Hexidecimal';
    pnSubstring:
        lblFormat.Caption := 'Substring';
    pnLetters:
        lblFormat.Caption := 'Change Numbers to Letters';
    else
        lblFormat.Caption := 'none';
    end;
end;
procedure TfrmMetaVariables.ParseFormatting(s: string);
var amount : string;
begin
    self.SetFormatPage(0);
    if (s = '') or (s = ':') then EXIT;

    s := unittoken.clipOneChar(s);
    case uppercase(s[1])[1] of
        'L': {left "L 3"} begin
           self.SetFormatPage(1);
           cbpad.ItemIndex := 0;
           try
                s := clipOneChar(s);
                txtChar.Text := s[1];
                s := clipOneChar(s);
                txtLength.Text := s;
                updown1.Position := StrToInt(s);
           except

           end;
        end;
        'R': {right} begin
           self.SetFormatPage(1);
           cbpad.ItemIndex := 1;
           try
                s := clipOneChar(s);
                txtChar.Text := s[1];
                s := clipOneChar(s);
                txtLength.Text := s;
                updown1.Position := StrToInt(s);
           except

           end;

        end;
        'D': {decimal} begin
            self.SetFormatPage(2);
            try
                s := clipOneChar(s);
                txtDecimal.text := s;
                updown2.Position := StrToInt(s);
            except

            end;
        end;
        'F': {date Format} begin
            self.SetFormatPage(3);
            try
                s := clipOneChar(s);
                txtDateFormat.text := s;
            except

            end;
        end;
        'C': {date C[P][0][xx][F]yyyy} begin
            self.SetFormatPage(3);
            try
                s := clipOneChar(s);
                if s[1] = 'P' then begin
                    cbxAlter.ItemIndex := 0;
                end else begin
                    cbxAlter.ItemIndex := 1;
                end;
                s := clipOneChar(s);
                cbxAlterUnits.ItemIndex := StrToInt(s[1]);
                s := clipOneChar(s);
                amount := UnitToken.TokenString(s,'F');
                txtAlterAmount.Text := amount;
                txtDateFormat.text := s;
            except

            end;
        end;

        'H': {hex} begin
            self.SetFormatPage(4);
            try
                s := clipOneChar(s);
                txtHexPad.text := s;
                updown3.Position := StrToInt(s);
            except

            end;
        end;
        'S': {substring} begin
            self.SetFormatPage(5);
            try
                s := clipOneChar(s);

                txtSubX.text := UnitToken.TokenString(s,'.') ;
                txtSubY.text := s;
            except

            end;
        end;
        'T': {letters} begin
            self.SetFormatPage(6);
            try
                s := clipOneChar(s);
                cbStartWithZero.checked := (s='0');
            except

            end;
        end;
    end;
end;
function TfrmMetaVariables.MetaFormat(s : string) : string;
var fm : string;
    op, units : string;
begin
    // generate the "?tag:FORMAT?" style meta-variable
    // given "?tag?"
    fm := ':';

    case FormatPageName(pcFormat.ActivePageIndex) of
    pnNone:;
    pnPadding:
        begin
            if cbPad.Text = 'Left' then begin
                fm := fm + 'L';
            end else begin
                fm := fm + 'R';
            end;
            fm := fm + txtChar.text;
            fm := fm + txtLength.text;
        end;
    pnDecimal:
        fm := fm + 'D' + txtDecimal.text;
    pnDate:
        begin
            if SafeInt(txtAlterAmount.text) <> 0  then begin
                if cbxAlter.ItemIndex = 0  then begin
                    op := 'P';
                end else begin
                    op := 'M';
                end;
                units := intToStr(cbxAlterUnits.ItemIndex);
                fm := fm + 'C' + op + units + txtAlterAmount.text + 'F' + trim(txtDateFormat.text);
            end else begin
                fm := fm + 'F' + trim(txtDateFormat.text);
            end;
        end;
    pnHex:
        fm := fm + 'H' + txtHexPad.text;
    pnSubstring:
        fm := fm + 'S' + txtSubX.text + '.' + txtSubY.text;
    pnLetters:
        begin
            if cbStartWithZero.checked then begin
                fm := fm + 'T0';
            end else begin
                fm := fm + 'T1';
            end;
        end;
    end;


    if fm <> ':' then
        insert(fm, s,  length(s));
    result := s;
end;

procedure TfrmMetaVariables.FormatClick(Sender: TObject);
begin
    self.SetFormatPage( StrToInt(TMenuItem(sender).hint) );
    lblFormat.Caption := TMenuItem(sender).caption;
    self.UpdatePreview;
end;
procedure TfrmMetaVariables.rbVariableClick(Sender: TObject);
var rb : TRadioButton;
    i : integer;
    t : string;
    curVar : string;
    procedure uncheck(l : TRadioList; exclude : TRadioButton);
    var rb : TRadioButton;
    begin
        for rb in l do begin
            if rb <> exclude then begin
                rb.checked := false;
            end;
        end;
    end;

begin
    if not assigned(self) then EXIT;

    rb := TRadioButton(Sender);
    if rb.checked = true then begin
        if listName.Contains(rb) then begin
            uncheck(listname, rb);
        end else if listCount.Contains(rb) then begin
            uncheck(listCount, rb);
        end else if listDate.Contains(rb) then begin
            uncheck(listDate, rb);
        end else if listName.Contains(rb) then begin
            uncheck(listName, rb);
        end else if ListSize.Contains(rb) then begin
            uncheck(ListSize, rb);
        end else if listDateToday.Contains(rb) then begin
            uncheck(listDateToday, rb);
        end;
    end else begin
        EXIT;
    end;

    // counting
    if rb = rbFCCurrent then begin
        i := SafeInt(txtzeros.text, 2);
        txtzeros.text := inttostr(i);

        if i < 10 then begin
            curVar :=  var_number_base + '0' + txtzeros.Text + VAR_NUMBER_SUFFIX;
        end else begin
            curVar :=  var_number_base + txtzeros.Text + VAR_NUMBER_SUFFIX;
        end;
    end else if rb = rbFCTotalSelected then begin
        curVar := VAR_SELECTED_COUNT;
    end else if rb = rbRFTotal then begin
        curVar := VAR_COUNT;
    end else if rb = rbFCTotalFolder then begin
        curVar := VAR_FOLDER_COUNT


    // name
    end else if rb = rbFPType then begin
        curVar := VAR_TYPE;
    end else if rb = rbFPName then begin
        curVar := VAR_CUR_FILENAME;
    end else if rb = rbFilenameOnly then begin
        curVar := VAR_CUR_FILENAME_NOEXT;
    end else if rb = rbFPCurFolder then begin
        curVar := VAR_CUR_FOLDER;
    end else if rb = rbFPParent then begin
        curVar := VAR_PAR_FOLDER;
    end else if rb = rbFileContents then begin
        t := 'P';
        if cbxTextEncode.ItemIndex = 1 then begin
            t := 'U';
        end;
        curVar :=
            '?FC'+t+'_'+IntToSTr(SafeInt(txtContentsA.text, 1))+
            '.'+IntToStr(SafeInt(txtContentsB.text, 2)) + '?';

    // date
    end else if rb = rbFPDateshort then begin
        curVar := VAR_CUR_DATE_SHORT;
    end else if rb = rbFPDatemedium then begin
        curVar := VAR_CUR_DATE_MEDIUM;
    end else if rb = rbFPDatelong then begin
        curVar := VAR_CUR_DATE_LONG;
    end else if rb = rbFPDateModified then begin
        curVar := VAR_DATE_MODIFIED;
    end else if rb = rbFPDateCreated then begin
        curVar := VAR_DATE_CREATED;

    // size
    end else if rb = rbFSBytes then begin
        case cbxlayout.ItemIndex  of
        0: curVar := VAR_SIZE;
        1: curVar := VAR_SIZE_COMMAS;
        2: curVar := VAR_SIZE; // no need for decimals
        end;
    end else if rb = rbFSKilos then begin
        case cbxlayout.ItemIndex  of
        0: curVar := VAR_SIZE_KILO;
        1: curVar := VAR_SIZE_KILO_COMMAS;
        2: curVar := VAR_SIZE_KILO_2DEC;
        end;
    end else if rb = rbFSMegs then begin
        case cbxlayout.ItemIndex  of
        0: curVar := VAR_SIZE_MEGS;
        1: curVar := VAR_SIZE_MEGS_COMMAS;
        2: curVar := VAR_SIZE_MEGS_2DEC;
        end;
    end else if rb = rbFSGigs then begin
        case cbxlayout.ItemIndex  of
        0: curVar :=  VAR_SIZE_GIGS;
        1: curVar :=  VAR_SIZE_GIGS_COMMAS;
        2: curVar :=  VAR_SIZE_GIGS_2DEC;
        end;

    // date today
    end else if rb = rbTDDateshort then begin
        curVar := VAR_CUR_DATE_SHORT;
    end else if rb = rbTDDateMedium then begin
        curVar := VAR_CUR_DATE_MEDIUM;
    end else if rb = rbTDDatelong then begin
        curVar := VAR_CUR_DATE_LONG;
    end;

    self.SetVariable(curVar);

    UpdatePreview;
end;
procedure TfrmMetaVariables.FileSelectedCallback(filename : string);
var
    ext : string;
begin
    self.previewFile := filename;
    self.UpdatePreview;

    FrameCheckedFileDropdown1.setCurrent(self.previewFile);
    framFileTags1.extractFrom(
        TPath.Combine( FrmMain.GetPath, self.previewFile)
    );

    self.UpdateExtensionPanel;
end;
procedure TfrmMetaVariables.ChangeHandler(Sender: Tobject);
    procedure HandleZerosChange;
    begin
        try
            if strtoint(txtzeros.text) < 10 then begin
                self.SetVariable(var_number_base + '0' + txtzeros.Text + VAR_NUMBER_SUFFIX);
            end else begin
                self.SetVariable(var_number_base + txtzeros.Text + VAR_NUMBER_SUFFIX);
            end;
        finally
        end;
    end;
    procedure HandleLayout;
    var rb : TRadioButton;
    begin
        if rbFSBytes.Checked then  rbFSBytes.OnClick(rbFSBytes);
        if rbFSKilos.Checked then  rbFSKilos.OnClick(rbFSKilos);
        if rbFSMegs.Checked then  rbFSMegs.OnClick(rbFSMegs);
        if rbFSGigs.Checked then  rbFSGigs.OnClick(rbFSGigs);
    end;
    procedure HandleContent;
    begin
        if rbFileContents.Checked then begin
            rbFileContents.OnClick(rbFileContents);
        end;
    end;
    procedure HandleFormatting;
    begin

    end;
begin
    if sender = txtZeros then  HandleZerosChange;
    if sender = cbxLayout then HandleLayout;
    if sender = cbxTextEncode then HandleContent;
    if sender = txtContentsA then HandleContent;
    if sender = txtContentsb then HandleContent;

    self.UpdatePreview;
end;
procedure TfrmMetaVariables.UpdatePreview;
var rr : RenameRecord;
    i : integer;
    s : string;
    formattedVar : string;
begin

    i := FrmDummyShowPreview.FindByFilename(self.previewFile);
    if i = -1 then EXIT;

    FrmDummyShowPreview.GetRecord(rr, i);

    formattedVar := MetaFormat(self.selectedVar);

    s := UnitMetaVariables.ReplaceMetaVariables(
        formattedVar,
        rr
    );

    if s = '' then begin
        lblPreview.caption := '[none]';
    end else begin
        lblPreview.caption :=  s;
    end;

    UnitMetaVariables.SetNoCleanOnce;
    previewRaw := UnitMetaVariables.ReplaceMetaVariables(
        formattedVar,
        rr
    );
    UnitMetaVariables.ClearNoCleanOnce;
end;
procedure TfrmMetaVariables.UpdateExtensionPanel;
var
    ext : string;
begin
    ext := LowerCase( TPath.GetExtension(self.previewFile) );
    pnlExtension.Visible := not StringIn(ext, supported_files);
    framFileTags1.Visible := not pnlExtension.Visible;
end;

procedure TfrmMetaVariables.FileTagCallback(tagVar : string);
begin
    if formatmode then EXIT;

    self.SetVariable(tagVar);
    updatePreview;
end;

end.
