unit UnitFrameToolbar;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, 
  Dialogs, ExtCtrls;

type
  TFrameToolbar = class(TFrame)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    Splitter3: TSplitter;
    Splitter4: TSplitter;
  private
    { Private declarations }
    function GetPanel(index : integer): TPanel;


  public
    { Public declarations }

    property panel[Index: Integer] : TPanel read GetPanel;
    procedure InitToolbar;
  end;

implementation

uses UnitFrmMain, Buttons;

{$R *.dfm}

{ TFrame1 }


function TFrameToolbar.GetPanel(index: integer): TPanel;
begin
    result := nil;

    case index of
    0: result := Panel1;
    1: result := panel2;
    2: result := panel3;
    3: result := panel4;
    4: result := panel5;
    end;
end;

procedure TFrameToolbar.InitToolbar;
var i, j, x{, cnt} : integer;
    pnl : TPanel;
    btn : TSPeedButton;
begin
  inherited;
  for i := 0 to FrmMain.MainMenu1.Items.count - 1 do begin
        if i >= 5 then BREAK; // workaround for adding new menu items;

        pnl := self.panel[i];
        pnl.ShowHint := true;
        pnl.Hint := '';
        pnl.Height := 34;
        pnl.width := 20;

        x := 0;
        //cnt := 0;


        for j := 0 to FrmMain.MainMenu1.Items[i].count - 1 do begin
            if FrmMain.MainMenu1.Items[i][j].IsLine then continue;
            if not assigned(FrmMain.MainMenu1.Items[i][j].OnClick) then continue;
            if not FrmMain.MainMenu1.Items[i][j].Visible then continue;

            //if (self.MainMenu1.Items[i][j].bitmap.Empty) then continue;
            if (FrmMain.MainMenu1.Items[i][j].ImageIndex = -1) then continue;

            btn := TSpeedButton.Create(pnl);
            btn.Align := alLeft;
            btn.Parent := pnl;

            btn.OnClick := FrmMain.MainMenu1.Items[i][j].OnClick;
            btn.Hint := FrmMain.MainMenu1.Items[i][j].Caption;
            btn.caption := '';
            btn.Flat := true;
            FrmMain.ilmenus.GetBitmap(FrmMain.MainMenu1.Items[i][j].imageindex, btn.Glyph);
            btn.Width := 25;
            btn.Height := 25;
            btn.ShowHint := true;



            inc(x, btn.Width + 2);
        end;
        pnl.width := x + 20 ;
   end;

end;

end.
