unit UnitFrmSelectFolder;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ShellCtrls, StdCtrls, ShellAPI, ShlObj, FileCtrl;

type
  TfrmSelectFolder = class(TForm)
    btnOK: TButton;
    btnCancel: TButton;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    procedure FormCreate(Sender: TObject);
    procedure DriveComboBox1Change(Sender: TObject);
    procedure DirectoryListBox1Click(Sender: TObject);

  private
    { Private declarations }
     //lpItemID : PItemIDList;
     BrowseInfo : TBrowseInfo;
     title: string;
     DisplayName : array[0..MAX_PATH] of char;
     //TempPath : array[0..MAX_PATH] of char;
     //root: pitemidlist;

    {function BrowseDialog
     (const Title: string; const Flag: integer): string;}

  public
    { Public declarations }
    function GetSelectedFolder() : string;
  end;

var
  frmSelectFolder: TfrmSelectFolder;

implementation

uses UnitFrmConfig, UnitFormScaling;

{$R *.dfm}



{function tfrmselectfolder.BrowseDialog
 (const Title: string; const Flag: integer): string;
var
  lpItemID : PItemIDList;
  //BrowseInfo : TBrowseInfo;
begin
  Result:='';

  BrowseInfo.pidlroot := root;

  lpItemID := SHBrowseForFolder(BrowseInfo);
  if lpItemId <> nil then begin
    SHGetPathFromIDList(lpItemID, TempPath);
    Result := TempPath;
    GlobalFreePtr(lpItemID);
  end;

  root := BrowseInfo.pidlroot;
end;
}


function TFrmSelectFolder.GetSelectedFolder() : string;
begin
   self.ShowModal;
   if (self.ModalResult = mrok) then begin
        result := directorylistbox1.Directory
   end else begin
        result := '';
   end;



    //if (shelltv.SelectedFolder <> nil) and (self.ModalResult = mrok) then begin
     //   result := shelltv.selectedfolder.PathName;
    //end;
end;



procedure TfrmSelectFolder.FormCreate(Sender: TObject);
begin
  FillChar(BrowseInfo, sizeof(TBrowseInfo), #0);

    title := 'Select a Folder';


    with BrowseInfo do begin
        hwndOwner := Application.Handle;
        pszDisplayName := @DisplayName;
        lpszTitle := PChar(Title);
        ulFlags := 0;

    end;

    TFormScaling.RegisterSelf(self);
end;


procedure TfrmSelectFolder.DriveComboBox1Change(Sender: TObject);
begin
    DirectoryListBox1.Directory := DriveComboBox1.Drive + ':\';
end;

procedure TfrmSelectFolder.DirectoryListBox1Click(Sender: TObject);
begin

    {for i := 0 to directorylistbox1.Items.Count - 1 do begin
        if DirectoryListBox1.Selected[i] then DirectoryListBox1.ItemIndex := i;
    end;
    }
    directorylistbox1.OpenCurrent;

    //directorylistbox1.Directory := directorylistbox1.Items[directorylistbox1.ItemIndex];
end;

end.
