unit UnitFrmWizardGettingStarted;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, ComCtrls, ExtCtrls, StdCtrls;

type
  TFrmWizardGettingStarted = class(TForm)
    Panel1: TPanel;
    pcPanels: TPageControl;
    TabSheet1: TTabSheet;
    Panel2: TPanel;
    btnBack: TSpeedButton;
    btnNext: TSpeedButton;
    btnCancel: TSpeedButton;
    TabSheet2: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    TabSheet3: TTabSheet;
    Label3: TLabel;
    Label4: TLabel;
    RichEdit1: TRichEdit;
    RichEdit2: TRichEdit;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Panel3: TPanel;
    Image2: TImage;
    Panel4: TPanel;
    Image3: TImage;
    TabSheet4: TTabSheet;
    Label5: TLabel;
    SpeedButton4: TSpeedButton;
    Panel5: TPanel;
    Image4: TImage;
    Label7: TLabel;
    Label8: TLabel;
    Panel6: TPanel;
    Image5: TImage;
    Label9: TLabel;
    RichEdit3: TRichEdit;
    RichEdit4: TRichEdit;
    TabSheet5: TTabSheet;
    Panel7: TPanel;
    Image6: TImage;
    SpeedButton5: TSpeedButton;
    Label10: TLabel;
    RichEdit5: TRichEdit;
    TabSheet6: TTabSheet;
    Label6: TLabel;
    RichEdit6: TRichEdit;
    pnl1: TPanel;
    txtTFind: TEdit;
    SpeedButton6: TSpeedButton;
    Label11: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnBackClick(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
  private
    { Private declarations }
    procedure CheckButtonStates;
  public
    { Public declarations }
  end;

var
  FrmWizardGettingStarted: TFrmWizardGettingStarted;

implementation

uses UnitFrmMain, UnitFormScaling;

{$R *.dfm}

procedure TFrmWizardGettingStarted.btnBackClick(Sender: TObject);
begin
    pcPanels.ActivePageIndex :=     pcPanels.ActivePageIndex - 1;
    self.CheckButtonStates;     
end;

procedure TFrmWizardGettingStarted.btnCancelClick(Sender: TObject);
begin
    self.Close; 
end;

procedure TFrmWizardGettingStarted.btnNextClick(Sender: TObject);
begin
    pcPanels.ActivePageIndex :=     pcPanels.ActivePageIndex + 1;

    self.CheckButtonStates;
end;

procedure TFrmWizardGettingStarted.CheckButtonStates;
begin
    btnBack.Enabled := true;
    btnNext.Enabled := true;
    if pcPanels.ActivePageIndex = 0 then begin
        btnBack.Enabled := false;
    end;
    if pcpanels.ActivePageIndex = pcpanels.PageCount - 1 then begin
        btnNext.Enabled := false;
    end;
end;

procedure TFrmWizardGettingStarted.FormCreate(Sender: TObject);
var i : integer;
begin
    // always on top
     Windows.SetWindowPos(self.Handle, HWND_TOPMOST, 0, 0, 0, 0,
        (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOOWNERZORDER or
                         SWP_NOZORDER Or SWP_FRAMECHANGED ) and not SWP_NOZORDER);


    for i := 0 to pcPanels.PageCount - 1 do begin
        pcPanels.Pages[i].TabVisible := false;
    end;


    TFormScaling.RegisterSelf(self);
   // memo1.ParentColor := true;
end;

procedure TFrmWizardGettingStarted.FormShow(Sender: TObject);
var i,j : integer;
    sb : TSpeedButton;
begin
    pcPanels.ActivePageIndex := 0;
    self.CheckButtonStates;

    for i := 0 to pcPanels.PageCount  - 1 do begin
        for j := 0 to pcPanels.pages[i].ControlCount  - 1 do begin
            if pcpanels.Pages[i].Controls[j] is TSpeedButton then begin
               sb := TSpeedButton(pcpanels.Pages[i].Controls[j]);
               sb.Visible := true;
               sb.click;
               sb.Visible := false;
            end;
        end;
    end;
end;

procedure TFrmWizardGettingStarted.SpeedButton1Click(Sender: TObject);
begin
    image5.Invalidate;
    image5.Picture := nil;

    frmmain.pnlFolderStuff.PaintTo(
        self.image5.Canvas,
        0,
        0
    );

end;

procedure TFrmWizardGettingStarted.SpeedButton2Click(Sender: TObject);
begin
    image2.Invalidate;
    image2.Picture := nil;

    if not frmmain.BrowsePanelShowing then
        frmmain.btnBrowser.click;


    frmmain.pnlBrowse.PaintTo(
        self.image2.Canvas,
        0,
        0
    );

    if frmmain.BrowsePanelShowing then
        frmmain.btnBrowser.click;


end;

procedure TFrmWizardGettingStarted.SpeedButton3Click(Sender: TObject);
begin
    image3.Picture := nil;
    FrmMain.pcTemplate.ActivePageIndex := FrmMain.tsScripting.PageIndex;
    frmmain.lvFileList.PaintTo(self.image3.canvas,0,0);
end;

procedure TFrmWizardGettingStarted.SpeedButton4Click(Sender: TObject);
begin
    image4.Invalidate;
    image4.Picture := nil;



    frmmain.pcTemplate.PaintTo(
        self.image4.Canvas,
        0,
        0
    );
end;

procedure TFrmWizardGettingStarted.SpeedButton5Click(Sender: TObject);
var b : boolean;
begin
    image6.Picture := nil;
    image6.Invalidate;



    if frmmain.MiniRenamingButtons1.checked then begin
        b := FrmMain.btnUndomini.Enabled;
        FrmMain.btnUndomini.Enabled := true;
        frmmain.pnlRenameButtons.PaintTo(image6.Canvas,0,0);
        FrmMain.btnUndomini.Enabled := b;
    end else begin
        b := FrmMain.btnUndo.Enabled;
        FrmMain.btnUndo.Enabled := true;
        frmmain.pnlMainButtons.PaintTo(image6.Canvas,0,0);
        FrmMain.btnUndo.Enabled := b;
    end;
end;

end.
